# -*- coding: utf-8 -*-

import utils
from qgis.core import *
from qgis.PyQt.QtWidgets import *

def my_form_open(dialog, layer, feature):

	combo_tipo_i = dialog.findChild(QComboBox,"combo_tipo_i")
	combo_tipo_z = dialog.findChild(QComboBox,"combo_tipo_z")
	lineedit_tipo_i = dialog.findChild(QLineEdit,"Tipo_i")

	codici_instab = []
	codici_instab_layer = QgsMapLayerRegistry.instance().mapLayersByName("codici_Instab_Tipo_i")[0]
	for i in codici_instab_layer.getFeatures(QgsFeatureRequest().setFlags(QgsFeatureRequest.NoGeometry)):
		codici_instab.append(i.attributes()[1])
	combo_tipo_i.addItem("")
	for c in codici_instab:
		combo_tipo_i.addItem(c)

	codici_zone = []
	codici_zone_layer = QgsMapLayerRegistry.instance().mapLayersByName("codici_Tipo_z")[0]
	for i in codici_zone_layer.getFeatures(QgsFeatureRequest().setFlags(QgsFeatureRequest.NoGeometry)):
		if int(i.attributes()[0]) > 2000:
			codici_zone.append(i.attributes()[1])
	combo_tipo_z.addItem("")
	for c in codici_zone:
		combo_tipo_z.addItem(c)

	combo_tipo_i.currentIndexChanged.connect(lambda: update_lineedit_tipo_i(combo_tipo_i, combo_tipo_z, lineedit_tipo_i))
	combo_tipo_z.currentIndexChanged.connect(lambda: update_lineedit_tipo_i(combo_tipo_i, combo_tipo_z, lineedit_tipo_i))

	idx = layer.fieldNameIndex("ID_i")
	if idx > -1:
		attrs = feature.attributes()
    	if len(attrs) > idx and attrs[idx] == NULL:
			prog = utils.get_next_prog(layer, "ID_i")
			control = dialog.findChild(QWidget, "ID_i")
			control.setText(prog)

def update_lineedit_tipo_i(combo_tipo_i, combo_tipo_z, lineedit_tipo_i):
	tipo_i = combo_tipo_i.currentText().strip()[:4]
	tipo_z = combo_tipo_z.currentText().strip()[:4]
	if tipo_i is None:
		tipo_i = ""
	elif tipo_i == "3060" or tipo_i == "3070" or tipo_i == "3080" or tipo_i == "3061" or tipo_i == "3062":
		combo_tipo_z.setEnabled(False)
		combo_tipo_z.setCurrentIndex(0)
		tipo_z = ""
	else:
		combo_tipo_z.setEnabled(True)
	if tipo_z is None:
		tipo_z = ""
	lineedit_tipo_i.setText(tipo_i + tipo_z)
